--- old/usr/src/tools/scripts/check_rtime.pl	2018-02-20 04:36:00.693978502 +0000
+++ new/usr/src/tools/scripts/check_rtime.pl	2018-02-20 04:36:00.725292037 +0000
@@ -96,6 +96,12 @@
 #   EXEC_STACK
 #	Objects that are not required to have a non-executable stack
 #
+#   FORBIDDEN_DEP
+#	Objects allowed to link to 'forbidden' objects
+#
+#   FORBIDDEN
+#	Objects to which nobody not excepted with FORBIDDEN_DEP may link
+#
 #   NOCRLEALT
 #	Objects that should be skipped by AltObjectConfig() when building
 #	the crle script that maps objects to the proto area.
@@ -138,7 +144,7 @@
 #
 
 use vars  qw($EXRE_exec_data $EXRE_exec_stack $EXRE_nocrlealt);
-use vars  qw($EXRE_nodirect $EXRE_nosymsort);
+use vars  qw($EXRE_nodirect $EXRE_nosymsort $EXRE_forbidden_dep $EXRE_forbidden);
 use vars  qw($EXRE_olddep $EXRE_skip $EXRE_stab $EXRE_textrel $EXRE_undef_ref);
 use vars  qw($EXRE_unref_obj $EXRE_unused_deps $EXRE_unused_obj);
 use vars  qw($EXRE_unused_rpath);
@@ -443,6 +449,7 @@
 			onbld_elfmod::OutMsg($ErrFH, $ErrTtl, $RelPath, $Line);
 			next;
 		}
+                
 		# Look for unreferenced dependencies.  Note, if any unreferenced
 		# objects are ignored, then set $UnDep so as to suppress any
 		# associated unused-object messages.
@@ -577,13 +584,23 @@
 			if (defined($EXRE_olddep) && ($Need =~ $EXRE_olddep)) {
 				# Catch any old (unnecessary) dependencies.
 				onbld_elfmod::OutMsg($ErrFH, $ErrTtl, $RelPath,
-			"NEEDED=$Need\t<dependency no longer necessary>");
+				    "NEEDED=$Need\t<dependency no " .
+				    "longer necessary>");
+			} elsif (defined($EXRE_forbidden) && 
+			    ($Need =~ $EXRE_forbidden)) {
+				next if defined($EXRE_forbidden_dep) &&
+				    ($FullPath =~ $EXRE_forbidden_dep);
+
+				onbld_elfmod::OutMsg($ErrFH, $ErrTtl, $RelPath, 
+				    "NEEDED=$Need\t<forbidden dependency, " .
+				    "missing -nodefaultlibs?>");
+				next;
 			} elsif ($opt{i}) {
 				# Under the -i (information) option print out
 				# any useful dynamic entries.
 				onbld_elfmod::OutMsg($InfoFH, $InfoTtl, $RelPath,
 				    "NEEDED=$Need");
-			}
+                	}
 			next;
 		}
 
